(***********************************************************)
(*							   *)
(*	 ஡  ࠧ室    ᪠ N x N	   *)
(*							   *)
(*		     .		   *)
(*	  ⬨ +    = ணࠬ	   *)
(*							   *)
(*		     ॢ  ᪨:		   *)
(*	     , 1980,  "".   158.	   *)
(*							   *)
(***********************************************************)

program KnightStour; {$I-,R-}
  {$define print}	  {     ﭨ }
  {$define asterisk} {    */-  ன  }
const
  N = 5;	     {   ᪠ N x N }
  Nmoves = 8;	     { ன ꧬ 室  类  }
  MaxMoveNo = N * N; { ᨬ   室 }
type
  MovesRange = 0 .. MaxMoveNo;
  index = 0 .. N+3; { ᨢ  - ࠤ ࠭⥫ }
		    {  ᪠  ।⠢  ᨢ  }
	   {  2  N+1. 0, 1, N+2, N+3  ࠭⥫ }
var
  i, j: index;
  Succ: boolean;
  NSuccess: Word;
  hh, vv: array [0..Nmoves] of integer;
  Board: array [index, index] of Byte;
{$ifdef print}
  const
    Processed = '*'; { ⡥梨 ᯥ譮 ६ 室 }
    Remain = '-';		      { ⠢ 室 }
  var
    SuccShow: array [0..MaxMoveNo] of char;
{$endif}

procedure PrintBoard;
var
  i, j: integer;
begin
  { ⯥⢠  室 ᪠,
		 室  ࠭ }
  write(' '); for i:= 2 to N do write('');
  writeln('Ŀ');
  for i:= 2 to N + 1 do
  begin
    for j:= 2 to N + 1 do write(' ', Board[i, j]: 3);
    writeln(' ');
    if i <> N + 1 then
    begin
      write(' ');
      for j:= 1 to N - 1 do write('');
      writeln('ĳ')
    end
  end { for i };
  write(' '); for i:= 2 to N do write('');
  writeln('')
end { PrintBoard };

procedure TryMove(i: MovesRange; x, y: index);
var
  k: MovesRange;
  u, v: integer;
begin
  {$ifdef print}
    {$ifdef asterisk}
      SuccShow[i]:= Processed;
    {$else}
      SuccShow[i]:= '1';
    {$endif}
    write(SuccShow);
  {$endif}
  k:= 0;
  repeat
    Inc(k); Succ:= false; u:= x + hh[k]; v:= y + vv[k];
    if Board[u, v] = 0 then
    begin { ᢮  ? }
      Board[u, v]:= i;
      {$ifdef print}
	{$ifNdef asterisk}
	  SuccShow[i]:= chr(ord('0') + k);
	{$endif}
      {$endif}
      if i < N * N then
      begin { ⮢ ᫥ 室  ? }
	TryMove(i + 1, u, v);
	if not Succ then Board[u, v]:= 0
      end
      else begin
	{$ifdef print}
	  write(#13);
	{$endif}
	writeln('One possible solution is:');
	PrintBoard; Inc(NSuccess);
	{$ifdef print}
	  SuccShow[N * N]:= Processed;
	{$endif}
	Succ:= true; {   ᬥ ᯥ. }
	{        ஡  㣨 ꧬ }
	{ 襭,  ⮣     孠 }
	{ ୨ ᪮  ᫥ : }
      { writeln(Nsuccess, ' solution(s) found.') }
      end
    end
  until Succ or (k = 8);
  {$ifdef print}
    if not Succ then SuccShow[i]:= Remain
  {$endif}
end { TryMove };

begin
  { 樠ࠬ ꧬ 
	ꤥ    ⨤    }
  hh[1]:=  2; hh[2]:=  1; hh[3]:= -1; hh[4]:= -2;
  hh[5]:= -2; hh[6]:= -1; hh[7]:=  1; hh[8]:=  2;
  vv[1]:=  1; vv[2]:=  2; vv[3]:=  2; vv[4]:=  1;
  vv[5]:= -1; vv[6]:= -2; vv[7]:= -2; vv[8]:= -1;
  { ⢠ 﫠 ᪠.      室. }
  FillChar(Board, SizeOf(Board), #0); writeln;
  { ꫢ ࢨ  ᫥  ।  ࠭⥫. }
  FillChar(Board[  0], SizeOf(Board[  0]) * 2, #$ff);
  FillChar(Board[N+2], SizeOf(Board[N+2]) * 2, #$ff);
  { ꫢ ࢨ  ᫥  ꫡ  ࠭⥫. }
  for i:= 2 to N + 1 do
  begin
    Board[i, 0]:= $ff; Board[i, 1]:= $ff;
    Board[i, N + 2]:= $ff; Board[i, N + 3]:= $ff
  end { for i };
  {$ifdef print}
    { 樠ࠬ    }
    {$ifdef asterisk}
      FillChar(SuccShow, SizeOf(SuccShow), Remain);
      SuccShow[1]:= Processed;
    {$else}
      FillChar(SuccShow, SizeOf(SuccShow), ' ');
    {$endif}
    SuccShow[0]:= #13;
    { ⮢    Message file, ..  }
  {$endif}
  writeln('UniPascal demonstration program!'); writeln;
  writeln(' Knight store on a ', N, ' x ', N, ' board.');
  { 碠  ୨  .    ࠢ
	横  窨 ! }
  Board[2, 2]:= 1; Nsuccess:= 0; TryMove(2, 2, 2);
  if Nsuccess = 0 then write('The problem have no solution.')
end { Knight Store }.