{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
program Play;
uses Crt;
const
  fnt : array [1..13] of string[5] =
    ('','#','','#','','','#',
      '','#','','#','','');
  f : array [1..12] of Word =
    (330,349,370,392,415,440,466,494,523,554,588,622);
var
  fm : file of Byte;
  fs, ntp : Word;
  okt, note, len, pau, tmb : Byte;

procedure PlayNote(fp, len, pau : Word);
begin
  if note=0 then
  begin
    fp:=0; ntp:=13
  end;
  Write('⠢:':10,okt:3);
  Write(':':10,fnt[ntp]:7);
  Write('⥫쭮:':18,len:5);
  Write('㧠:':10,pau:5,#13);
  Sound(fp); Delay(len*7); NoSound; Delay(pau*7);
  if KeyPressed then if ReadKey=#27 then
  begin
    Write(#13'.'); ClrEol; WriteLn; Halt(0)
  end
end;

begin
  Write(#10#13'   ');
  WriteLn('   :');
  WriteLn('<>,<>,<>...':43,#10#13);
  if ParamCount<>1 then
  begin
    WriteLn('PLAY <_>'); Halt(0)
  end;
  Assign(fm,ParamStr(1)); Reset(fm);
  if IOresult<>0 then
  begin
    WriteLn(#7'   "',ParamStr(1),'"');
    Halt(1)
  end;
  Write(' : "',ParamStr(1),'"...');
  WriteLn('(  - "ESC" )':25);
  repeat
    Read(fm,note); Read(fm,len); Read(fm,pau); Read(fm,tmb);
    okt:=note div 12; ntp:=(note mod 12)+1;
    fs:=Trunc(f[ntp]*Exp((okt-1)*Ln(2)));
    PlayNote(fs,len,pau);
    if tmb<$f5 then Seek(fm,FilePos(fm)-1)
  until (tmb=$ff) or Eof(fm) or (IOresult<>0);
  Write(#13' .');
  Close(fm); ClrEol; WriteLn
end { Play }.