program UnAsm;
label 1,2;
const
  lines: word = 0;
  adr: word = $100;
  hd: array [0..15] of char='0123456789abcdef';
  instr: array [0..106] of
    record
      mnem: string[4];
      code: array [0..5] of byte
    end = (
	(mnem: 'aba' ; code: ($1b,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'adca'; code: (0  ,$89,$99,$b9,$a9,0  )),
	(mnem: 'adcb'; code: (0  ,$c9,$d9,$f9,$e9,0  )),
	(mnem: 'adda'; code: (0  ,$8b,$9b,$bb,$ab,0  )),
	(mnem: 'addb'; code: (0  ,$cb,$db,$fb,$eb,0  )),
	(mnem: 'anda'; code: (0  ,$84,$94,$b4,$a4,0  )),
	(mnem: 'andb'; code: (0  ,$c4,$d4,$f4,$e4,0  )),
	(mnem: 'asl' ; code: (0  ,0  ,0  ,$78,$68,0  )),
	(mnem: 'asla'; code: ($48,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'aslb'; code: ($58,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'asr' ; code: (0  ,0  ,0  ,$77,$67,0  )),
	(mnem: 'asra'; code: ($47,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'asrb'; code: ($57,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'bcc' ; code: (0  ,0  ,0  ,0  ,0  ,$24)),
	(mnem: 'bcs' ; code: (0  ,0  ,0  ,0  ,0  ,$25)),
	(mnem: 'beq' ; code: (0  ,0  ,0  ,0  ,0  ,$27)),
	(mnem: 'bge' ; code: (0  ,0  ,0  ,0  ,0  ,$2c)),
	(mnem: 'bgt' ; code: (0  ,0  ,0  ,0  ,0  ,$2e)),
	(mnem: 'bhi' ; code: (0  ,0  ,0  ,0  ,0  ,$22)),
	(mnem: 'bita'; code: (0  ,$85,$95,$b5,$a5,0  )),
	(mnem: 'bitb'; code: (0  ,$c5,$d5,$f5,$e5,0  )),
	(mnem: 'ble' ; code: (0  ,0  ,0  ,0  ,0  ,$2f)),
	(mnem: 'bls' ; code: (0  ,0  ,0  ,0  ,0  ,$23)),
	(mnem: 'blt' ; code: (0  ,0  ,0  ,0  ,0  ,$2d)),
	(mnem: 'bmi' ; code: (0  ,0  ,0  ,0  ,0  ,$2b)),
	(mnem: 'bne' ; code: (0  ,0  ,0  ,0  ,0  ,$26)),
	(mnem: 'bpl' ; code: (0  ,0  ,0  ,0  ,0  ,$2a)),
	(mnem: 'bra' ; code: (0  ,0  ,0  ,0  ,0  ,$20)),
	(mnem: 'bsr' ; code: (0  ,0  ,0  ,0  ,0  ,$8d)),
	(mnem: 'bvc' ; code: (0  ,0  ,0  ,0  ,0  ,$28)),
	(mnem: 'bvs' ; code: (0  ,0  ,0  ,0  ,0  ,$29)),
	(mnem: 'cba' ; code: ($11,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'clc' ; code: ($c ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'cli' ; code: ($e ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'clr' ; code: (0  ,0  ,0  ,$7f,$6f,0  )),
	(mnem: 'clra'; code: ($4f,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'clrb'; code: ($5f,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'clv' ; code: ($a ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'cmpa'; code: (0  ,$81,$91,$b1,$a1,0  )),
	(mnem: 'cmpb'; code: (0  ,$c1,$d1,$f1,$e1,0  )),
	(mnem: 'com' ; code: (0  ,0  ,0  ,$73,$63,0  )),
	(mnem: 'coma'; code: ($43,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'comb'; code: ($53,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'cpx' ; code: (0  ,$8c,$9c,$bc,$ac,0  )), (**)
	(mnem: 'daa' ; code: ($19,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'dec' ; code: (0  ,0  ,0  ,$7a,$6a,0  )),
	(mnem: 'deca'; code: ($4a,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'decb'; code: ($5a,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'des' ; code: ($34,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'dex' ; code: ($09,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'eora'; code: (0  ,$88,$98,$b8,$a8,0  )),
	(mnem: 'eorb'; code: (0  ,$c8,$d8,$f8,$e8,0  )),
	(mnem: 'inc' ; code: (0  ,0  ,0  ,$7c,$6c,0  )),
	(mnem: 'inca'; code: ($4c,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'incb'; code: ($5c,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'ins' ; code: ($31,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'int' ; code: (0  ,0  ,$3f,0  ,0  ,0  )),
	(mnem: 'inx' ; code: ($08,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'jmp' ; code: (0  ,0  ,0  ,$7e,$6e,0  )),
	(mnem: 'jsr' ; code: (0  ,0  ,0  ,$bd,$ad,0  )),
	(mnem: 'ldaa'; code: (0  ,$86,$96,$b6,$a6,0  )),
	(mnem: 'ldab'; code: (0  ,$c6,$d6,$f6,$e6,0  )),
	(mnem: 'lds' ; code: (0  ,$8e,$9e,$be,$ae,0  )), (**)
	(mnem: 'ldx' ; code: (0  ,$ce,$de,$fe,$ee,0  )), (**)
	(mnem: 'lsr' ; code: (0  ,0  ,0  ,$74,$64,0  )),
	(mnem: 'lsra'; code: ($44,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'lsrb'; code: ($54,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'neg' ; code: (0  ,0  ,0  ,$70,$60,0  )),
	(mnem: 'nega'; code: ($40,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'negb'; code: ($50,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'nop' ; code: ($01,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'oraa'; code: (0  ,$8a,$9a,$ba,$aa,0  )),
	(mnem: 'orab'; code: (0  ,$ca,$da,$fa,$ea,0  )),
	(mnem: 'psha'; code: ($36,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'pshb'; code: ($37,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'pula'; code: ($32,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'pulb'; code: ($33,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'rol' ; code: (0  ,0  ,0  ,$79,$69,0  )),
	(mnem: 'rola'; code: ($49,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'rolb'; code: ($59,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'ror' ; code: (0  ,0  ,0  ,$76,$66,0  )),
	(mnem: 'rora'; code: ($46,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'rorb'; code: ($56,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'rti' ; code: ($3b,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'rts' ; code: ($39,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'sba' ; code: ($10,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'sbca'; code: (0  ,$82,$92,$b2,$a2,0  )),
	(mnem: 'sbcb'; code: (0  ,$c2,$d2,$f2,$e2,0  )),
	(mnem: 'sec' ; code: ($d ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'sei' ; code: ($f ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'sev' ; code: ($b ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'staa'; code: (0  ,0  ,$97,$b7,$a7,0  )),
	(mnem: 'stab'; code: (0  ,0  ,$d7,$f7,$e7,0  )),
	(mnem: 'sts' ; code: (0  ,0  ,$9f,$bf,$af,0  )),
	(mnem: 'stx' ; code: (0  ,0  ,$df,$ff,$ef,0  )),
	(mnem: 'suba'; code: (0  ,$80,$90,$b0,$a0,0  )),
	(mnem: 'subb'; code: (0  ,$c0,$d0,$f0,$e0,0  )),
	(mnem: 'tab' ; code: ($16,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tap' ; code: ($6 ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tba' ; code: ($17,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tpa' ; code: ($7 ,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tst' ; code: (0  ,0  ,0  ,$7d,$6d,0  )),
	(mnem: 'tsta'; code: ($4d,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tstb'; code: ($5d,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'tsx' ; code: ($30,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'txs' ; code: ($35,0  ,0  ,0  ,0  ,0  )),
	(mnem: 'wai' ; code: ($3e,0  ,0  ,0  ,0  ,0  )));
var
  f2: text;
  f: file of byte;
  mi,op,vi,nam1,nam2: string;
  ii,i: word;
  ua,sh,ch2,ch1: byte;

function hex(c:byte):string;
begin
  hex:=hd[c shr 4]+hd[c and $0f]
end;

function hex2(c:word):string;
begin
  hex2:=hex(hi(c))+hex(lo(c))
end;

procedure p3r(u:byte);
begin
  if eof(f) then exit else
  begin
    read(f,ch1); if eof(f) then exit else read(f,ch2)
  end;
  ua:=3; op:=hex(ch1)+hex(ch2);
  vi:='$'+op; if u=1 then vi:='#'+vi
end;

procedure idp(u:byte);
begin
  if eof(f) then exit else read(f,ch1);
  ua:=2; op:=hex(ch1); vi:='$'+hex(ch1);
  case u of
    2:vi:=vi+',x'; 3:vi:='#'+vi
  end
end;

procedure rel;
begin
  if eof(f) then exit else read(f,ch1);
  ua:=2; op:=hex(ch1);
  if ch1>127 then vi:='$'+hex2(adr+ch1-254)
    else vi:='$'+hex2(adr+ch1+2)
end;

procedure acm;
begin
  ua:=1; op:=''; vi:=#0
end;

begin
  writeln('UnAssembly programm for processor 601'); writeln;
  if paramcount<>2 then
  begin
    writeln('Usage: UNASM <CMD-file> <TEXT-file>'); halt
  end;
  nam1:=paramstr(1); nam2:=paramstr(2);
  assign(f,nam1); assign(f2,nam2); reset(f);
  if IOresult<>0 then
  begin
    writeln('Can''t open file ''',nam1,''''); halt
  end;
  rewrite(f2); writeln('UnAssembling ...');
  writeln(f2,'The UnAssembly-List of file ''',nam1,''':');
  repeat
    read(f,sh);
    for i:=0 to 106 do
    begin
      ii:=0;
      repeat
	if (sh<>0) and (sh=instr[i].code[ii]) then goto 1;
	inc(ii)
      until ii>5
    end;
    mi:='???'; acm; goto 2;
    1: mi:=instr[i].mnem;
    case ii of
      1: if sh in [$8c, $8e, $ce] then p3r(1) else idp(3); (**)
      2: idp(1); 3: p3r(2); 4: idp(2); 5: rel else acm
    end;
    2: write(f2,hex2(adr),': ',hex(sh),' ',op,#9,mi);
    if vi<>#0 then writeln(f2,#9+vi) else writeln(f2);
    if IOresult<>0 then
    begin
      writeln(#7'I/O error'); close(f); close(f2); halt
    end;
    inc(adr,ua); inc(lines);
    if lines mod 128=0 then write(#13,lines:7)
  until eof(f);
  writeln(#13,lines+2:7,' lines in ',nam2);
  write(f2,'End of UnAssembly-List, (',lines+2,' lines).');
  writeln; writeln(nam1,' -- ',filesize(f),' bytes');
  writeln(nam2,' -- ',lines,' instructions (',lines+2,' lines).');
  close(f); close(f2)
end { UnAsm }.